# generate-defaults [![NPM version](https://img.shields.io/npm/v/generate-defaults.svg?style=flat)](https://www.npmjs.com/package/generate-defaults) [![NPM downloads](https://img.shields.io/npm/dm/generate-defaults.svg?style=flat)](https://npmjs.org/package/generate-defaults) [![Build Status](https://img.shields.io/travis/generate/generate-defaults.svg?style=flat)](https://travis-ci.org/generate/generate-defaults)

> Use this generator to add some common default settings to your 'generate', verb, and assemble generators.

You might also be interested in [generate](https://github.com/generate/generate).

## Table of Contents

- [Install](#install)
- [Usage](#usage)
- [What does this do?](#what-does-this-do)
- [About](#about)
  * [Related projects](#related-projects)
  * [Contributing](#contributing)
  * [Building docs](#building-docs)
  * [Running tests](#running-tests)
  * [Author](#author)
  * [License](#license)

_(TOC generated by [verb](https://github.com/verbose/verb) using [markdown-toc](https://github.com/jonschlinkert/markdown-toc))_

## Install

Install with [npm](https://www.npmjs.com/):

```sh
$ npm install --save generate-defaults
```

## Usage

Register as a plugin in your generator:

```js
module.exports = function(app) {
  app.use(require('generate-defaults'));
  // do generator stuff
};
```

## What does this do?

* Loads the [common-middleware](https://github.com/jonschlinkert/common-middleware) plugin
* Loads the [common-questions](https://github.com/generate/common-questions) plugin
* Loads the [verb-repo-data](https://github.com/verbose/verb-repo-data) plugin, to add repository data to the context
* Registers [engine-base](https://github.com/jonschlinkert/engine-base) as the default template engine
* Registers [template-helpers](https://github.com/jonschlinkert/template-helpers) as the default template engine
* Registers a `check-directory` task, which prompts the user if they want to procede when a directory has files in it.

Any of these features can be overridden after this plugin is registered.

## About

### Related projects

* [assemble](https://www.npmjs.com/package/assemble): Get the rocks out of your socks! Assemble makes you fast at creating web projects… [more](https://github.com/assemble/assemble) | [homepage](https://github.com/assemble/assemble "Get the rocks out of your socks! Assemble makes you fast at creating web projects. Assemble is used by thousands of projects for rapid prototyping, creating themes, scaffolds, boilerplates, e-books, UI components, API documentation, blogs, building websit")
* [generate](https://www.npmjs.com/package/generate): Command line tool and developer framework for scaffolding out new GitHub projects. Generate offers the… [more](https://github.com/generate/generate) | [homepage](https://github.com/generate/generate "Command line tool and developer framework for scaffolding out new GitHub projects. Generate offers the robustness and configurability of Yeoman, the expressiveness and simplicity of Slush, and more powerful flow control and composability than either.")
* [verb](https://www.npmjs.com/package/verb): Documentation generator for GitHub projects. Verb is extremely powerful, easy to use, and is used… [more](https://github.com/verbose/verb) | [homepage](https://github.com/verbose/verb "Documentation generator for GitHub projects. Verb is extremely powerful, easy to use, and is used on hundreds of projects of all sizes to generate everything from API docs to readmes.")

### Contributing

Pull requests and stars are always welcome. For bugs and feature requests, [please create an issue](../../issues/new).

### Building docs

_(This document was generated by [verb-generate-readme](https://github.com/verbose/verb-generate-readme) (a [verb](https://github.com/verbose/verb) generator), please don't edit the readme directly. Any changes to the readme must be made in [.verb.md](.verb.md).)_

To generate the readme and API documentation with [verb](https://github.com/verbose/verb):

```sh
$ npm install -g verb verb-generate-readme && verb
```

### Running tests

Install dev dependencies:

```sh
$ npm install -d && npm test
```

### Author

**Jon Schlinkert**

* [github/jonschlinkert](https://github.com/jonschlinkert)
* [twitter/jonschlinkert](http://twitter.com/jonschlinkert)

### License

Copyright © 2016, [Jon Schlinkert](https://github.com/jonschlinkert).
Released under the [MIT license](https://github.com/generate/generate-defaults/blob/master/LICENSE).

***

_This file was generated by [verb-generate-readme](https://github.com/verbose/verb-generate-readme), v0.1.31, on September 19, 2016._